import numpy as np
from scipy.signal import stft
from scipy.signal import istft

def bwExtUpsamplingSolution(pfSignalNarrow, fSamplerateBroad, iNfft, iFrameshift):
    # Upsample signal
    pfZeroSignal = np.zeros(np.size(pfSignalNarrow))
    pfSignalBroad = np.insert(pfZeroSignal, np.arange(len(pfSignalNarrow)), pfSignalNarrow)

    # STFT of signal
    pfFreqVecBroad, _, ppcSignalBroad = stft(pfSignalBroad, fs=fSamplerateBroad, nperseg=iNfft, noverlap=iNfft-iFrameshift)

    # Create very basic attenuation filter
    pfFilter = np.ones(np.size(pfFreqVecBroad))
    pfFilter[int(np.round(iNfft/4)+1):] = 1 - (1 - 0.1) * np.arange(np.round(iNfft/4)) / np.round(iNfft/4)

    # Apply filter
    ppcFilteredSignalBroad = np.multiply(pfFilter[:,None], ppcSignalBroad)

    # ISTFT of filtered signal
    _, pfFilteredSignalBroad = istft(ppcFilteredSignalBroad, fs=fSamplerateBroad, nperseg=iNfft, noverlap=iNfft-iFrameshift)

    return pfFilteredSignalBroad, pfFilter