from scipy.signal import butter, sosfiltfilt, sosfreqz

def filterSignal(pfSignal, fLowCutoffFreq, fHighCutoffFreq, fSamplerate, iOrder=30):
    # Design filter
    fSamplerateHalf = fSamplerate / 2.0
    fLowCutoff = fLowCutoffFreq / fSamplerateHalf
    fHighCutoff = fHighCutoffFreq / fSamplerateHalf
    sos = butter(iOrder, [fLowCutoff, fHighCutoff], analog=False, btype='band', output='sos')

    # Apply filter
    pfFilteredSignal = sosfiltfilt(sos, pfSignal)
    return pfFilteredSignal